# wxVScrolledWindow Class Reference
[Miscellaneous Windows]

`#include <wx/vscroll.h>`

Inheritance diagram for wxVScrolledWindow:
[legend]

## Detailed Description

In the name of this class, "V" may stand for "variable" because it can be used for scrolling rows of variable heights; "virtual", because it is not necessary to know the heights of all rows in advance -- only those which are shown on the screen need to be measured; or even "vertical", because this class only supports scrolling vertically.

In any case, this is a generalization of wxScrolled which can be only used when all rows have the same heights. It lacks some other wxScrolled features however, notably it can't scroll specific pixel sizes of the window or its exact client area size.

To use this class, you need to derive from it and implement the OnGetRowHeight() pure virtual method. You also must call SetRowCount() to let the base class know how many rows it should display, but from that moment on the scrolling is handled entirely by wxVScrolledWindow. You only need to draw the visible part of contents in your `OnPaint()` method as usual. You should use GetVisibleRowsBegin() and GetVisibleRowsEnd() to select the lines to display. Note that the device context origin is not shifted so the first visible row always appears at the point (0, 0) in physical as well as logical coordinates.

## wxWidgets 2.8 Compatibility Functions

The following functions provide backwards compatibility for applications originally built using wxVScrolledWindow in 2.6 or 2.8. Originally, wxVScrolledWindow referred to scrolling "lines". We now use "units" in wxVarScrollHelperBase to avoid implying any orientation (since the functions are used for both horizontal and vertical scrolling in derived classes). And in the new wxVScrolledWindow and wxHScrolledWindow classes, we refer to them as "rows" and "columns", respectively. This is to help clear some confusion in not only those classes, but also in wxHVScrolledWindow where functions are inherited from both.

You are encouraged to update any existing code using these function to use the new replacements mentioned below, and avoid using these functions for any new code as they are deprecated.

`size_t GetFirstVisibleLine() const` | Deprecated for GetVisibleRowsBegin().
`size_t GetLastVisibleLine() const` | Deprecated for GetVisibleRowsEnd(). This function originally had a slight design flaw in that it was possible to return `(size_t)-1` (ie: a large positive number) if the scroll position was 0 and the first line wasn't completely visible.
`size_t GetLineCount() const` | Deprecated for GetRowCount().
`int HitTest(wxCoord x, wxCoord y) const int HitTest(const wxPoint& pt) const` | Deprecated for VirtualHitTest().
`virtual wxCoord OnGetLineHeight(size_t line) const` | Deprecated for OnGetRowHeight().
`virtual void OnGetLinesHint(size_t lineMin, size_t lineMax) const` | Deprecated for OnGetRowsHeightHint().
`virtual void RefreshLine(size_t line)` | Deprecated for RefreshRow().
`virtual void RefreshLines(size_t from, size_t to)` | Deprecated for RefreshRows().
`virtual bool ScrollLines(int lines)` | Deprecated for ScrollRows().
`virtual bool ScrollPages(int pages)` | Deprecated for ScrollRowPages().
`bool ScrollToLine(size_t line)` | Deprecated for ScrollToRow().
`void SetLineCount(size_t count)` | Deprecated for SetRowCount().

##

Library: wxCore

Category: Miscellaneous Windows

See also:
  wxHScrolledWindow, wxHVScrolledWindow

## Public Member Functions
| wxVScrolledWindow ()
| Default constructor, you must call Create() later.
| wxVScrolledWindow (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| This is the normal constructor, no need to call Create() after using this constructor.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Same as the non-default constructor, but returns a status code: true if ok, false if the window couldn't be created.

List of all members.

## Constructor & Destructor Documentation

wxVScrolledWindow::wxVScrolledWindow | ( |  | ) |

Default constructor, you must call Create() later.

wxVScrolledWindow::wxVScrolledWindow | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxPanelNameStr` |
| ) |  |  |

This is the normal constructor, no need to call Create() after using this constructor.

Note:
  `wxVSCROLL` is always automatically added to the style, there is no need to specify it explicitly.

Parameters:

  | parent | The parent window, must not be NULL.
  | id | The identifier of this window, wxID_ANY by default.
  | pos | The initial window position.
  | size | The initial window size.
  | style | The window style. There are no special style bits defined for this class.
  | name | The name for this window; usually not used.

## Member Function Documentation

bool wxVScrolledWindow::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxPanelNameStr` |
| ) |  |  |

Same as the non-default constructor, but returns a status code: true if ok, false if the window couldn't be created.

Just as with the constructor, the `wxVSCROLL` style is always used, there is no need to specify it explicitly.

Reimplemented from wxPanel.

Reimplemented in wxHtmlListBox, and wxVListBox.

|  | [ top ]